// -------------------------------------------------------------------
//                        ExCapture Ver.0.1.4
//                     rfILv`Cu
// -------------------------------------------------------------------
// 
// ExCapture
// The MIT License
// Copyright (c) 2009 Hirofumi Uemura and Sunao Hashimoto
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//
//
// ExCapture
// MITCZX
// Copyright (c) 2009 Hirofumi Uemura and Sunao Hashimoto
//
// ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tg
// EFAvj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ
// ŋ܂Bɂ́A\tgEFA̕gpAʁAύXAAfځA
// ЕzATuCZXA/܂͔̔錠Aу\tgEFA񋟂
// ɓƂ錠Ɋ܂܂܂B 
//
// L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
// ɋLڂ̂Ƃ܂B 
// 
// \tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ
// Ȃ񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KA
// NQɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B 
// ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tg
// EFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈
// Đ؂̐AQȂ̋`ɂĉ̐ӔCȂ
// Ƃ܂B 
//

#include "ExCapture.h"

//------------------------------------------------------------------------------------
// NXCap_SampleGrabberCB̃o֐̒`
// RXgN^
Cap_SampleGrabberCB::Cap_SampleGrabberCB() {
	tm = 0.0;
	//O[oϐgpȂ߂̃oϐ
	pbuf_CB = NULL;
	bufsize_CB = NULL;
	time_CB = NULL;
	wx_CB = 0;
	wy_CB = 0;
}
// fXgN^
Cap_SampleGrabberCB::~Cap_SampleGrabberCB() {
}

STDMETHODIMP_(ULONG) Cap_SampleGrabberCB::AddRef() {
	return 2;
}
STDMETHODIMP_(ULONG) Cap_SampleGrabberCB::Release() {
	tm = 0.0;
	//O[oϐgpȂ߂̃oϐ
	pbuf_CB = NULL;
	bufsize_CB = NULL;
	time_CB = NULL;
	wx_CB = 0;
	wy_CB = 0;
	return 1;
}
STDMETHODIMP Cap_SampleGrabberCB::QueryInterface( REFIID riid, void **ppv ) {
	if ( riid == IID_ISampleGrabberCB || riid == IID_IUnknown ) {
		*ppv = (void*)static_cast<ISampleGrabberCB*>(this);
		return NOERROR;
	}
	return E_NOINTERFACE;
}
STDMETHODIMP Cap_SampleGrabberCB::SampleCB( double SampleTime, IMediaSample *pSample ) {
	return S_OK;
}
// t[ɌĂ΂֐
STDMETHODIMP Cap_SampleGrabberCB::BufferCB( double dblSampleTime, BYTE *pBuffer, long lBufferSize ) {
	*bufsize_CB = lBufferSize;
	//摜Rs[
	memcpy( (unsigned char*)pbuf_CB, pBuffer, lBufferSize );
	*time_CB = dblSampleTime;

	return S_OK;
}
void Cap_SampleGrabberCB::TimeSet( double *t ) {
	*t = tm = *time_CB;
}
int Cap_SampleGrabberCB::IsCaptured() {
	//V摜΁COt[̉摜擾tmƂꂪ͂Ȃ̂
	//̂oĂDꂪEXC_SUCCESS(V摜)Ԃ
	if ( tm != *time_CB ) {
		tm = *time_CB; //tmŐV̂̂ɍXV
		return EXC_SUCCESS;
	}
	return EXC_ERROR;
}
//------------------------------------------------------------------------------------








// ExCaptureNX̒`
//------------------------------------------------------------------------------------
// RXgN^
ExCapture::ExCapture() {
	m_flag_open = EXC_ERROR;
	m_use_num = 0;
	m_pGraphBuilder = NULL;
	m_pMediaControl = NULL;
	for( int i=0;i<EXC_MAX_DEV_NUM;i++ ) dsInit( m_dshow[i] );
}
//------------------------------------------------------------------------------------
// fXgN^
ExCapture::~ExCapture() {
	if ( m_flag_open == EXC_SUCCESS ) Close();
	for( int i=0;i<EXC_MAX_DEV_NUM;i++ ) dsRelease( m_dshow[i] );
}
//------------------------------------------------------------------------------------
// DSHOWDATA\̂̏
void ExCapture::dsInit( DSHOWDATA &dshow ) {
	ZeroMemory( dshow.DeviceName, EXC_STR_LENGTH );
	dshow.Bmi = BITMAPINFO();
	dshow.PinData = PINDATA();
	dshow.pSampleGrabber = NULL;
	dshow.pCaptureGraphBuilder2 = NULL;
	dshow.pDeviceFilter = NULL;
	dshow.pVideoRenderer = NULL;
	dshow.pSampleGrabber = NULL;
	dshow.pIAMVideoProcAmp = NULL;
	dshow.pIAMCameraControl = NULL;
	dshow.pIAMStreamConfig = NULL;
	dshow.pCrossbar = NULL;
	dshow.StreamPropertyIsBusy = false;
	dshow.SampleGrabberCB.Release();
	dshow.fps = 0.0;
	dshow.pbuf = NULL;
	dshow.buffer = NULL;
	dshow.bufsize = 0;
	dshow.time = 0.0;
	for( int i=0;i<EXC_ITEMMAX;i++ ) dshow.valueflag[i] = EXC_ERROR;
}
//------------------------------------------------------------------------------------
// DSHOWDATA\̗̂̈
void ExCapture::dsRelease( DSHOWDATA &dshow ) {
	if ( dshow.pCrossbar ) dshow.pCrossbar->Release();
	if ( dshow.pIAMStreamConfig ) dshow.pIAMStreamConfig->Release();
	if ( dshow.pIAMCameraControl ) dshow.pIAMCameraControl->Release();
	if ( dshow.pIAMVideoProcAmp ) dshow.pIAMVideoProcAmp->Release();
	if ( dshow.pSampleGrabber ) dshow.pSampleGrabber->Release();
	if ( dshow.pVideoRenderer ) dshow.pVideoRenderer->Release();
	if ( dshow.pDeviceFilter ) dshow.pDeviceFilter->Release();
	if ( dshow.pCaptureGraphBuilder2 ) dshow.pCaptureGraphBuilder2->Release();
	if ( dshow.pSampleGrabber ) dshow.pSampleGrabber->Release();
	if ( dshow.buffer ) delete [] dshow.buffer;
	dsInit( dshow );
}
//------------------------------------------------------------------------------------
// jJ̃foCX̎擾
void ExCapture::dsGetDeviceName( IMoniker *pMoniker, char DeviceName[] ) {
	IPropertyBag	*pPropBag;
	VARIANT			varName;

	pMoniker->BindToStorage( 0, 0, IID_IPropertyBag, (void**)&pPropBag );
	varName.vt = VT_BSTR;
	pPropBag->Read( L"FriendlyName", &varName, 0 );
	WideCharToMultiByte( CP_ACP, 0, varName.bstrVal, -1, DeviceName, EXC_STR_LENGTH, 0, 0 );
	SysFreeString( varName.bstrVal );
	pPropBag->Release();
}
//------------------------------------------------------------------------------------
// Lv`foCX̎擾
int ExCapture::dsGetDevice( DSHOWDATA dshow[], int n_request, bool flag_choose_device ) {
	int		n_use = 0;			// p\
	char	DevName[MAX_PATH];	// foCX
	WCHAR	wDevName[MAX_PATH];	// foCX(WideCharp)
	ULONG	nFetched = 0;
	char	DisplayName[EXC_STR_LENGTH];

	IMoniker		*pMoniker = NULL;
	ICreateDevEnum	*pCreateDevEnum = NULL;
	IEnumMoniker	*pEnumMoniker = NULL;
	int ret = IDCANCEL;

	// foCX񋓂邽߂CreateDevEnum𐶐(VXefoCX񋓎q̍쐬)
	m_hr = CoCreateInstance( CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, (PVOID*)&pCreateDevEnum );
	if ( FAILED(m_hr) ) return EXC_ERROR;

	// VideoInputDevice񋓂邽߂EnumMoniker𐶐(񋓎q̎擾)
	m_hr = pCreateDevEnum->CreateClassEnumerator( CLSID_VideoInputDeviceCategory, &pEnumMoniker, 0 );
	if ( FAILED(m_hr) ) {
		//foCX݂Ȃꍇ
		pCreateDevEnum->Release();
		pCreateDevEnum = NULL;
		return EXC_NO_DEVICE;
	}

	// jJ̎擾 foCXgpǂfɂ͂ǂ΁cH
	// Next̕]SUCCEEDEDgĂCfoCXׂđI΂ȂƂɃG[ɂȂ
	while( pEnumMoniker->Next( 1, &pMoniker, &nFetched ) == S_OK ) {
		// DisplayName̎擾
		LPOLESTR strMonikerName = 0;
		m_hr = pMoniker->GetDisplayName( NULL, NULL, &strMonikerName );
		if ( FAILED(m_hr) ) break;
		WideCharToMultiByte( CP_ACP, 0, strMonikerName, -1, DisplayName, EXC_STR_LENGTH, 0, 0 );

		// DisplayName"@device:pnp"Γo^
		if ( wcsstr( strMonikerName, L"@device:pnp" ) ) {

			ret = IDYES;
			// foCX(FriendlyName)̎擾
			dsGetDeviceName( pMoniker, DevName );
			//printf( "ExCapture::Message DevName:%s\n", DevName );
			MultiByteToWideChar( CP_ACP, 0, DevName, -1, wDevName, MAX_PATH );
			if ( flag_choose_device ) ret = MessageBoxW( NULL, wDevName, L"Do you use this device?", MB_YESNOCANCEL );


			if ( ret == IDCANCEL ) break;
			if ( ret == IDYES ) {
				// MonikerDeviceFilterBind (foCXgpǂ͂Ŕf\H->߂)
				m_hr = pMoniker->BindToObject( 0, 0, IID_IBaseFilter, (void**)&dshow[n_use].pDeviceFilter );
				if ( FAILED(m_hr) ) printf( "ExCapture::Message Bind FAILED\n" );
				if ( SUCCEEDED(m_hr) ) {
					// FilterGraphɃfoCXtB^ǉ
					m_hr = m_pGraphBuilder->AddFilter( dshow[n_use].pDeviceFilter, L"Device Fillter" );
					if ( FAILED(m_hr) ) break;
					// foCXRs[
					strcpy_s( dshow[n_use].DeviceName, DevName );
					n_use++;
					if (n_use==n_request) break;
				}
			}
		}
		pMoniker->Release();
		pMoniker = NULL;
	}

	//
	if ( pMoniker ) pMoniker->Release();
	if ( pEnumMoniker ) pEnumMoniker->Release();
	if ( pCreateDevEnum ) pCreateDevEnum->Release();

	if ( ret==IDCANCEL ) return EXC_CANCEL;
	if ( n_use <= 0 || n_use < n_request ) return EXC_ERROR;
	return n_use;
}
//------------------------------------------------------------------------------------
// jJ̃foCXݒ
int ExCapture::dsSetDevice( DSHOWDATA &dshow, int id, int width, int height, double fps, bool flag_choose_prop ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;
	// CaptureGraphBuilder2ƂLv`pGraphBuilder𐶐
	m_hr = CoCreateInstance( CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC_SERVER,
		IID_ICaptureGraphBuilder2, (void**)&dshow.pCaptureGraphBuilder2 );
	if ( FAILED(m_hr) ) return EXC_ERROR;
	// Lv`pGraphBuilderFilterGraphZbg
	m_hr = dshow.pCaptureGraphBuilder2->SetFiltergraph( m_pGraphBuilder );
	if ( FAILED(m_hr) ) return EXC_ERROR;
	// 摜TCYEt[[g̐ݒ---------------------------------------------------------------------
	// IAMStreamConfigC^tF[X̎擾
	m_hr = dshow.pCaptureGraphBuilder2->FindInterface( &PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video,
		dshow.pDeviceFilter, IID_IAMStreamConfig, (void**)&dshow.pIAMStreamConfig );
	if ( FAILED(m_hr) ) return EXC_ERROR;
	// lݒ
	if ( SetVideoProperty( id, width, height, fps, flag_choose_prop ) != EXC_SUCCESS ) {
		//printf( "dsSetDevice, SetVideoProperty FAILED\n" );
		return EXC_ERROR;
	}

	// ̓tH[}bg̐ݒ-------------------------------------------------------------------------------
	// SampleGrabber(Filter)𐶐
	m_hr = CoCreateInstance( CLSID_SampleGrabber, NULL, CLSCTX_INPROC_SERVER,
							 IID_IBaseFilter, (void**)&dshow.pSampleGrabberFilter );
	if ( FAILED(m_hr) ) return EXC_ERROR;
	// FilterISampleGrabberC^tF[X擾
	m_hr = dshow.pSampleGrabberFilter->QueryInterface( IID_ISampleGrabber, (void**)&dshow.pSampleGrabber );
	if ( FAILED(m_hr) ) return EXC_ERROR;
	// SampleGrabberڑtH[}bgݒ
	dsSetSGformat( dshow );
	// FillterGraphSampleGrabbertB^ǉ
	m_hr = m_pGraphBuilder->AddFilter( dshow.pSampleGrabberFilter, L"Sample Grabber" );
	if ( FAILED(m_hr) ) return EXC_ERROR;

	// TvOo̐ڑ-----------------------------------------------------------
	IPin *pSrcOut;
	IPin *pSGrabIn;
	// s̎擾
	pSrcOut  = dsGetPin( dshow.pDeviceFilter, PINDIR_OUTPUT );
	pSGrabIn = dsGetPin( dshow.pSampleGrabberFilter, PINDIR_INPUT );
	// s̐ڑ
	m_hr = m_pGraphBuilder->Connect( pSrcOut, pSGrabIn );
	if ( FAILED(m_hr) ) return EXC_ERROR;
	/*
	printf( "ExCapture::Message Connected\n" );
	printf( "\tOUT:%p\n", pSrcOut );
	printf( "\tIN :%p\n", pSGrabIn );
	*/
	pSrcOut->Release();
	pSGrabIn->Release();
	// Oõ[hݒ
	m_hr = dshow.pSampleGrabber->SetBufferSamples( FALSE );
	if ( FAILED(m_hr) ) return EXC_ERROR;
	m_hr = dshow.pSampleGrabber->SetOneShot( FALSE );
	if ( FAILED(m_hr) ) return EXC_ERROR;

	// NXo[̎擾---------------------------------------------------------------
	// ł܂NXo[͎gĂȂ...
	//if ( dsGetCrossBar( dshow ) != EXC_SUCCESS ) return EXC_ERROR;
	//printf( "dsSetDevice GetCrossBar OK\n" );


	// BMP̎擾-----------------------------------------------------------------
	dsGetBmi( dshow );

	// obt@̊m-----------------------------------------------------------------
	dshow.buffer = (int*)new int[dshow.Bmi.bmiHeader.biWidth*dshow.Bmi.bmiHeader.biHeight];
	dshow.pbuf = dshow.buffer;
	// R[obN֐pɃO[oϐgȂ悤ɂ邽߂̐ݒ
	dshow.SampleGrabberCB.pbuf_CB = dshow.pbuf;
	dshow.SampleGrabberCB.bufsize_CB = &dshow.bufsize;
	dshow.SampleGrabberCB.time_CB = &dshow.time;
	dshow.SampleGrabberCB.wx_CB = dshow.Bmi.bmiHeader.biWidth;
	dshow.SampleGrabberCB.wy_CB = dshow.Bmi.bmiHeader.biHeight;
	// R[obN֐̓o^
	m_hr = dshow.pSampleGrabber->SetCallback( &dshow.SampleGrabberCB, 1 );
	if ( FAILED(m_hr) ) return EXC_ERROR;

	// Jݒ舵߂̐ݒH-----------------------------------------------
	// IAMVideoPropcAmp擾
	m_hr = dshow.pDeviceFilter->QueryInterface( IID_IAMVideoProcAmp, (void**)&dshow.pIAMVideoProcAmp );
	if ( FAILED(m_hr) ) {
		// IAMVideoProcAmp擾łȂꍇCT|[gĂȂƂ݂Ȃ
		for( int j=0;j<EXC_VPAMPMAX;j++ ) dshow.valueflag[j] = 0;
	} else {
		for( int j=0;j<EXC_VPAMPMAX;j++ ) {
			long Min, Max, Step, Default, Flags;
			m_hr = dshow.pIAMVideoProcAmp->GetRange( j, &Min, &Max, &Step, &Default, &Flags );
			if ( SUCCEEDED(m_hr) ) dshow.valueflag[j] = 1;
			else				  dshow.valueflag[j] = 0;
		}
	}
	// IAMCameraControl擾
	m_hr = dshow.pDeviceFilter->QueryInterface( IID_IAMCameraControl, (void**)&dshow.pIAMCameraControl );
	if ( FAILED(m_hr) ) {
		// IAMCameraControl擾łȂꍇCT|[gĂȂƂ݂Ȃ
		for( int j=0;j<EXC_CAMCTLMAX;j++ ) dshow.valueflag[j+EXC_VPAMPMAX] = 0;
	} else {
		for( int j=0;j<EXC_CAMCTLMAX;j++ ) {
			long Min, Max, Step, Default, Flags;
			m_hr = dshow.pIAMCameraControl->GetRange( j, &Min, &Max, &Step, &Default, &Flags );
			if ( SUCCEEDED(m_hr) ) dshow.valueflag[j+EXC_VPAMPMAX] = 1;
			else				  dshow.valueflag[j+EXC_VPAMPMAX] = 0;
		}
/*
		//IAMCameraControl̃Rg[Ă̂m߂eXg
		for( int j=0;j<20;j++ ) {
			long Min, Max, Step, Default, Flags;
			m_hr = dshow.pIAMCameraControl->GetRange( j, &Min, &Max, &Step, &Default, &Flags );
			if ( SUCCEEDED(m_hr) ) {
				printf( "IAMCameracontrol #%2d is available:\n", j );
				printf( "\tMin, Max, Step, Default, Flags : %d, %d, %d, %d, %d\n", Min, Max, Step, Default, Flags );
			}
		}
*/
	}


	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// TvOõtH[}bgݒ
void ExCapture::dsSetSGformat( DSHOWDATA &dshow ) {
	AM_MEDIA_TYPE am_media_type;
	
	ZeroMemory( &am_media_type, sizeof(am_media_type) );
	am_media_type.majortype = MEDIATYPE_Video;
	am_media_type.subtype = MEDIA_TYPE;
	am_media_type.formattype = FORMAT_VideoInfo;

	m_hr = dshow.pSampleGrabber->SetMediaType( &am_media_type );
}
//------------------------------------------------------------------------------------
// NXo[̎擾
int ExCapture::dsGetCrossBar( DSHOWDATA &dshow ) {
	m_hr = dshow.pCaptureGraphBuilder2->FindInterface( &LOOK_UPSTREAM_ONLY, NULL,
		dshow.pDeviceFilter, IID_IAMCrossbar, (void**)&dshow.pCrossbar );
	if ( FAILED(m_hr) ) {
		//printf( "dsGetCrossBar FindInterface FAILED\n" );
		dshow.pCrossbar = NULL;
		return EXC_ERROR;
	}

	// PIN̐擾
	long nOutput = -1, nInput = -1;
	m_hr = dshow.pCrossbar->get_PinCounts( &nOutput, &nInput );
	if ( FAILED(m_hr) ) {
		//printf( "dsGetCrossBar get_PinCounts FAILED\n" );
		dshow.pCrossbar->Release();
		dshow.pCrossbar = NULL;
		return EXC_ERROR;
	}

	dshow.PinData.nInput = nInput;
	dshow.PinData.nOutput = nOutput;

	// oPIN̎擾
	for( long j=0;j<nOutput;j++ ) {
		long related = -1;
		dshow.pCrossbar->get_CrossbarPinInfo( false, j, &related, &dshow.PinData.TypeOutput[j] );
	}
	// PIN̎擾
	for( long j=0;j<nInput;j++ ) {
		long related = -1;
		dshow.pCrossbar->get_CrossbarPinInfo( true, j, &related, &dshow.PinData.TypeInput[j] );
	}

	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// Xg[`̃vpeB\
int ExCapture::dsShowStreamProperty( DSHOWDATA &dshow, bool flag_choose_prop ) {
	if ( !dshow.pIAMStreamConfig ) return EXC_ERROR;

	ISpecifyPropertyPages *pSpecifyPropertyPages = NULL;

	if ( flag_choose_prop ) {
		// 𑜓xȂǂύXꍇ
		m_hr = dshow.pIAMStreamConfig->QueryInterface( IID_ISpecifyPropertyPages, (void**)&pSpecifyPropertyPages );
	} else {
		// 邳ȂǃJݒύXꍇ
		m_hr = dshow.pDeviceFilter->QueryInterface( IID_ISpecifyPropertyPages, (void**)&pSpecifyPropertyPages );
	}
	if ( FAILED(m_hr) ) return EXC_ERROR;

	// foCXȂǂ̕\ݒ
	WCHAR wStr[EXC_STR_LENGTH];
	MultiByteToWideChar( CP_ACP, 0, dshow.DeviceName, -1, wStr, EXC_STR_LENGTH );

	// Unknown Filter擾
	IUnknown *pUnknownFilter;
	if ( flag_choose_prop ) {
		m_hr = dshow.pIAMStreamConfig->QueryInterface( IID_IUnknown, (void**)&pUnknownFilter );
	} else {
		m_hr = dshow.pDeviceFilter->QueryInterface( IID_IUnknown, (void**)&pUnknownFilter );
	}
	if ( FAILED(m_hr) ) {
		pSpecifyPropertyPages->Release();
		return EXC_ERROR;
	}

	// _CAOEChE\̂߂̐ݒ
	CAUUID caGUID;
	m_hr = pSpecifyPropertyPages->GetPages( &caGUID );
	if ( FAILED(m_hr) ) {
		pUnknownFilter->Release();
		pSpecifyPropertyPages->Release();
		return EXC_ERROR;
	}

	// _CAO̕\
	m_hr = OleCreatePropertyFrame( NULL, 0, 0, (LPCOLESTR)wStr, 1, &pUnknownFilter, caGUID.cElems, caGUID.pElems, 0, 0, NULL );
	if ( FAILED(m_hr) ) {
		pUnknownFilter->Release();
		pSpecifyPropertyPages->Release();
		return EXC_ERROR;
	}

	CoTaskMemFree( caGUID.pElems );
	pUnknownFilter->Release();

	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// rbg}bv̎擾
void ExCapture::dsGetBmi( DSHOWDATA &dshow ) {
	AM_MEDIA_TYPE am_media_type;
	VIDEOINFOHEADER *pVh;

	dshow.pSampleGrabber->GetConnectedMediaType( &am_media_type );
	pVh = (VIDEOINFOHEADER*)am_media_type.pbFormat;

	dshow.Bmi.bmiHeader = pVh->bmiHeader;
}
//------------------------------------------------------------------------------------
// s̎擾
IPin* ExCapture::dsGetPin( IBaseFilter *pFilter, PIN_DIRECTION PinDir ) {
	IEnumPins *pEnum;
	IPin *pPin = 0;

	m_hr = pFilter->EnumPins( &pEnum );
	if ( FAILED(m_hr) ) return NULL;

	while( SUCCEEDED(pEnum->Next( 1, &pPin, 0 )) ) {
		PIN_DIRECTION PinDirThis;
		pPin->QueryDirection( &PinDirThis );
		if ( PinDir == PinDirThis ) break;
		pPin->Release();
	}
	pEnum->Release();
	return pPin;
}

//------------------------------------------------------------------------------------
// Lv`foCX̃I[v
int ExCapture::Open( int n_request, int width, int height, double fps, bool flag_choose_device, bool flag_choose_prop ) {
	int i, n_use=0;

	// łɃfoCXJĂI
	if ( m_flag_open == EXC_SUCCESS ) return EXC_SUCCESS;

	// DirectShow֘A̕ϐ
	for( i=0;i<EXC_MAX_DEV_NUM;i++ ) {
		dsRelease( m_dshow[i] );
		dsInit( m_dshow[i] );
	}

	// COM
	m_hr = CoInitialize(NULL);
	if ( FAILED(m_hr) ) return EXC_ERROR;

	// FilterGraph𐶐
	// ExCapture Ƃ CLSCTX_INPROC_SERVER ̕Ⴄ
	m_hr = CoCreateInstance( CLSID_FilterGraph, 0, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, (void**)&m_pGraphBuilder );
	if ( FAILED(m_hr) ) {
		//printf( "ExCapture::Message CoCreateInstance FAILED\n" );
		Close();
		return EXC_ERROR;
	}

	// foCX̎擾
	n_use = dsGetDevice( m_dshow, n_request, flag_choose_device );
	// foCXȂ or rLZ ̏ꍇ
	if ( n_use == EXC_CANCEL ) {
		Close();
		//printf( "ExCapture::Message Process canceled\n" );
		return EXC_ERROR;
	}
	if ( n_use == EXC_ERROR ) {
		Close();
		//printf( "ExCapture::Message Error\n" );
		return EXC_ERROR;
	}
	if ( n_use <= 0 || n_use == EXC_NO_DEVICE ) {
		Close();
		//printf( "ExCapture::Message No device\n" );
		return EXC_ERROR;
	}
	m_use_num = n_use;

	// foCXݒ
	for( i=0;i<n_use;i++ ) {
		if ( dsSetDevice( m_dshow[i], i, width, height, fps, flag_choose_prop ) != EXC_SUCCESS ) {
			//printf( "ExCapture::Message Device setting FAILED\n" );
			Close();
			return EXC_ERROR;
		}
	}
	// MediaControlC^tF[X擾
	m_hr = m_pGraphBuilder->QueryInterface( IID_IMediaControl, (void**)&m_pMediaControl );
	if ( FAILED(m_hr) ) {
		//printf( "ExCapture::Message QueryInterface IID_IMediaControl FAILED\n" );
		Close();
		return EXC_ERROR;
	}
	// Lv`Jn
	m_hr = m_pMediaControl->Run();
	if ( FAILED(m_hr) ) {
		//printf( "ExCapture::Message IMediaControl Run FAILED\n" );
		Close();
		return EXC_ERROR;
	}
	// 1ȏTv܂őҋ@
	int t0, t;
	t0 = t = GetTickCount();
	while( m_dshow[0].bufsize <= 0 ) {
		t = GetTickCount();
		if ( (t-t0) > 3000 ) {
			//printf( "ExCapture::Message First capture FAILED\n" );
			Close();
			return EXC_ERROR;
		}
	}

	// Lv`\tOZbg
	m_flag_open = EXC_SUCCESS;
	m_use_num = n_use;
//	printf( "ExCapture::Message Opened num=%d\n", m_use_num );

	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// foCX̃N[Y
int ExCapture::Close() {
	// foCXI[vς݂̏ꍇCLv`~
	if ( m_flag_open == EXC_SUCCESS ) {
		if ( m_pMediaControl ) {
			int t0, t;
			t0 = t = GetTickCount();
			while( FAILED(m_pMediaControl->Stop()) ) {
				t = GetTickCount();
				if ( (t-t0) > 3000 ) break;
			}
		}
	}

	// eϐ
	if ( m_pMediaControl ) m_pMediaControl->Release();
	m_pMediaControl = NULL;
	for( int i=0;i<EXC_MAX_DEV_NUM;i++ ) {
		dsRelease( m_dshow[i] );
		dsInit( m_dshow[i] );
	}
	if ( m_pGraphBuilder ) m_pGraphBuilder->Release();
	m_pGraphBuilder = NULL;

	// COMACjVCY
	CoUninitialize();
	m_flag_open = EXC_ERROR;
	m_use_num = 0;
	//printf( "ExCapture::Message Closed\n" );

	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// rfI͂̐ݒ(𑜓xƂ)
int ExCapture::SetVideoProperty( int id, int width, int height, double fps, bool flag_choose_prop ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;
	// IAMStreamConfigC^tF[X݂Ȃ΃G[Ԃ
	if ( !m_dshow[id].pIAMStreamConfig ) return EXC_ERROR;

	AM_MEDIA_TYPE *pPmt;
	VIDEOINFOHEADER *pVh;
	int wx = width, wy = height;
	double wfps = fps;

	// Lv`foCXI[vĂꎞ~
	if ( m_flag_open == EXC_SUCCESS ) {
		m_hr = m_pMediaControl->Stop();
		if ( FAILED(m_hr) ) return EXC_ERROR;
	}

	// ݂̃fBAtH[}bg擾
	m_hr = m_dshow[id].pIAMStreamConfig->GetFormat( &pPmt );
	if ( FAILED(m_hr) ) return EXC_ERROR;
	pVh = (VIDEOINFOHEADER*)pPmt->pbFormat;
	m_dshow[id].Bmi.bmiHeader = pVh->bmiHeader;
	m_dshow[id].fps = 10000000.0/(double)pVh->AvgTimePerFrame;

	// Ƃ肠Őݒ肷
	pVh->bmiHeader.biWidth  = wx;
	pVh->bmiHeader.biHeight = wy;
	pVh->AvgTimePerFrame = (REFERENCE_TIME)floor(10000000.0/fps+0.5);
	m_hr = m_dshow[id].pIAMStreamConfig->SetFormat( pPmt );
	if ( FAILED(m_hr) && !flag_choose_prop ) return EXC_ERROR;

	// vpeBy[W\ĂŐݒ
	if ( flag_choose_prop ) {
		if ( dsShowStreamProperty( m_dshow[id], flag_choose_prop ) != EXC_SUCCESS ) return EXC_ERROR;
	}

	// ݒ̒lǂݏom_dshow[id]XV
	m_hr = m_dshow[id].pIAMStreamConfig->GetFormat( &pPmt );
	if ( FAILED(m_hr) ) return EXC_ERROR;
	pVh = (VIDEOINFOHEADER*)pPmt->pbFormat;
	m_dshow[id].Bmi.bmiHeader = pVh->bmiHeader;
	m_dshow[id].fps = 10000000.0/(double)pVh->AvgTimePerFrame;
	// R[obN֐̕ϐύX
	m_dshow[id].SampleGrabberCB.wx_CB = m_dshow[id].Bmi.bmiHeader.biWidth;
	m_dshow[id].SampleGrabberCB.wy_CB = m_dshow[id].Bmi.bmiHeader.biHeight;

	// Cobt@݂Ă΃obt@TCYύXė̈Ċm
	if ( m_dshow[id].buffer ) {
		m_dshow[id].bufsize = m_dshow[id].Bmi.bmiHeader.biWidth*m_dshow[id].Bmi.bmiHeader.biHeight;
		delete [] m_dshow[id].buffer;
		m_dshow[id].buffer = (int*)new int[m_dshow[id].bufsize];
		m_dshow[id].pbuf = m_dshow[id].buffer;
		// R[obN֐̕ϐXV
		m_dshow[id].SampleGrabberCB.pbuf_CB = m_dshow[id].pbuf;
		m_dshow[id].SampleGrabberCB.bufsize_CB = &m_dshow[id].bufsize;
	}

	// Lv`foCXJĂꍇɈꎞ~
	if ( m_flag_open == EXC_SUCCESS ) {
		m_hr = m_pMediaControl->Run();
		if ( FAILED(m_hr) ) return EXC_ERROR;
	}

	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// rfI͂̐ݒ(邳Ƃ)_CAO\Đݒ
int ExCapture::SetVideoImageProperty( int id ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;
	return dsShowStreamProperty( m_dshow[id], false );
}
//------------------------------------------------------------------------------------
// rbg}bv̎擾
void ExCapture::GetBmi( int id, BITMAPINFO *bmi ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return;
	*bmi = m_dshow[id].Bmi;
}
//------------------------------------------------------------------------------------
// foCX̎擾
void ExCapture::GetDeviceName( int id, char name[] ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return;
	strcpy_s( name, sizeof(name), m_dshow[id].DeviceName );
}
//------------------------------------------------------------------------------------
// s̎擾
void ExCapture::GetPinData( int id, PINDATA *PinData ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return;
	*PinData = m_dshow[id].PinData;
}
//------------------------------------------------------------------------------------
// ݒlǂݏo
double ExCapture::GetValue( int id, int prop, int *mode ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return -1.0;
	if ( prop < 0 || prop >= EXC_ITEMMAX ) return -1.0;
	if ( !m_dshow[id].valueflag[prop] ) return -1.0;

	long Min, Max, Step, Default, Flags, Val;

	if ( prop < EXC_VPAMPMAX ) {
		//IAMVideoProcAmp Lv`{[hpH
		//ݒl͈̔(W)擾
		m_hr = m_dshow[id].pIAMVideoProcAmp->GetRange( prop, &Min, &Max, &Step, &Default, &Flags );
		if ( FAILED(m_hr) ) return -1.0;
		//݂̐ݒl擾
		m_hr = m_dshow[id].pIAMVideoProcAmp->Get( prop, &Val, &Flags );
		if ( FAILED(m_hr) ) return -1.0;
		if ( mode != NULL ) {
			if ( Flags & VideoProcAmp_Flags_Auto ) *mode = 1;
			else *mode = 0;
		}
		return (double)(Val-Min)*100.0/(double)(Max-Min); //0.0`100.0ɐKlvZĕԂ
	} else {
		//IAMCameraControl WebJpH
		prop -= EXC_VPAMPMAX;
		//ݒl͈̔(W)擾
		m_hr = m_dshow[id].pIAMCameraControl->GetRange( prop, &Min, &Max, &Step, &Default, &Flags );
		if ( FAILED(m_hr) ) return -1.0;
		//݂̐ݒl擾
		m_hr = m_dshow[id].pIAMCameraControl->Get( prop, &Val, &Flags );
		if ( FAILED(m_hr) ) return -1.0;
		if ( mode != NULL ) {
			if ( Flags & CameraControl_Flags_Auto ) *mode = 1;
			else *mode = 0;
		}
		return (double)(Val-Min)*100.0/(double)(Max-Min); //0.0`100.0ɐKlvZĕԂ
	}
	return -1.0;
}
//------------------------------------------------------------------------------------
// 蓮ɂCݒlύX
int ExCapture::SetValue( int id, int prop, double value ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;
	if ( prop < 0 || prop >= EXC_ITEMMAX ) return EXC_ERROR;
	if ( !m_dshow[id].valueflag[prop] ) return EXC_ERROR;

	long Min, Max, Step, Default, Flags, Val;

	if ( prop < EXC_VPAMPMAX ) {
		//IAMVideoProcAmp
		m_hr = m_dshow[id].pIAMVideoProcAmp->GetRange( prop, &Min, &Max, &Step, &Default, &Flags );
		if ( FAILED(m_hr) ) return EXC_ERROR;
		//0.0`100.0̐KꂽlݒlvZ
		Val = (long)((value/100.0*(Max-Min))+Min);
		Val = min(max(Val,Min),Max);
		//蓮[hɂāClݒ
		m_hr = m_dshow[id].pIAMVideoProcAmp->Set( prop, Val, VideoProcAmp_Flags_Manual );
		if ( FAILED(m_hr) ) return EXC_ERROR;
	} else {
		//IAMCameraControl
		prop -= EXC_VPAMPMAX;
		m_hr = m_dshow[id].pIAMCameraControl->GetRange( prop, &Min, &Max, &Step, &Default, &Flags );
		if ( FAILED(m_hr) ) return EXC_ERROR;
		//0.0`100.0̐KꂽlݒlvZ
		Val = (long)((value/100.0*(Max-Min))+Min);
		Val = min(max(Val,Min),Max);
		//蓮[hɂāClݒ
		m_hr = m_dshow[id].pIAMCameraControl->Set( prop, Val, CameraControl_Flags_Manual );
		if ( FAILED(m_hr) ) return EXC_ERROR;
	}
	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// ݒlɖ߂
int ExCapture::SetDefault( int id, int prop ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;
	if ( prop < 0 || prop >= EXC_ITEMMAX ) return EXC_ERROR;
	if ( !m_dshow[id].valueflag[prop] ) return EXC_ERROR;

	long Min, Max, Step, Default, Flags, Val;

	if ( prop < EXC_VPAMPMAX ) {
		//IAMVideoProcAmp
		m_hr = m_dshow[id].pIAMVideoProcAmp->GetRange( prop, &Min, &Max, &Step, &Default, &Flags );
		if ( FAILED(m_hr) ) return EXC_ERROR;
		//Defaultݒ
		m_hr = m_dshow[id].pIAMVideoProcAmp->Get( prop, &Val, &Flags );
		m_hr = m_dshow[id].pIAMVideoProcAmp->Set( prop, Default, Flags );
		if ( FAILED(m_hr) ) return EXC_ERROR;
	} else {
		//IAMCameraControl
		prop -= EXC_VPAMPMAX;
		m_hr = m_dshow[id].pIAMCameraControl->GetRange( prop, &Min, &Max, &Step, &Default, &Flags );
		if ( FAILED(m_hr) ) return EXC_ERROR;
		//Defaultݒ
		m_hr = m_dshow[id].pIAMCameraControl->Get( prop, &Val, &Flags );
		m_hr = m_dshow[id].pIAMCameraControl->Set( prop, Default, Flags );
		if ( FAILED(m_hr) ) return EXC_ERROR;
	}
	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// [hɂ
int ExCapture::SetAuto( int id, int prop ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;
	if ( prop < 0 || prop >= EXC_ITEMMAX ) return EXC_ERROR;
	if ( !m_dshow[id].valueflag[prop] ) return EXC_ERROR;

	long Min, Max, Step, Default, Flags, Val;

	if ( prop < EXC_VPAMPMAX ) {
		//IAMVideoProcAmp
		m_hr = m_dshow[id].pIAMVideoProcAmp->GetRange( prop, &Min, &Max, &Step, &Default, &Flags );
		if ( FAILED(m_hr) ) return EXC_ERROR;
		//Autoݒ
		m_hr = m_dshow[id].pIAMVideoProcAmp->Get( prop, &Val, &Flags );
		m_hr = m_dshow[id].pIAMVideoProcAmp->Set( prop, Default, VideoProcAmp_Flags_Auto );
		if ( FAILED(m_hr) ) return EXC_ERROR;
	} else {
		//IAMCameraControl
		prop -= EXC_VPAMPMAX;
		m_hr = m_dshow[id].pIAMCameraControl->GetRange( prop, &Min, &Max, &Step, &Default, &Flags );
		if ( FAILED(m_hr) ) return EXC_ERROR;
		//Autoݒ
		m_hr = m_dshow[id].pIAMCameraControl->Get( prop, &Val, &Flags );
		m_hr = m_dshow[id].pIAMCameraControl->Set( prop, Default, CameraControl_Flags_Auto );
		if ( FAILED(m_hr) ) return EXC_ERROR;
	}
	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// 蓮[hɂ
int ExCapture::SetManu( int id, int prop ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;
	if ( prop < 0 || prop >= EXC_ITEMMAX ) return EXC_ERROR;
	if ( !m_dshow[id].valueflag[prop] ) return EXC_ERROR;

	long Min, Max, Step, Default, Flags, Val;

	if ( prop < EXC_VPAMPMAX ) {
		//IAMVideoProcAmp
		m_hr = m_dshow[id].pIAMVideoProcAmp->GetRange( prop, &Min, &Max, &Step, &Default, &Flags );
		if ( FAILED(m_hr) ) return EXC_ERROR;
		//Manualݒ
		m_hr = m_dshow[id].pIAMVideoProcAmp->Get( prop, &Val, &Flags );
		m_hr = m_dshow[id].pIAMVideoProcAmp->Set( prop, Val, VideoProcAmp_Flags_Manual );
		if ( FAILED(m_hr) ) return EXC_ERROR;
	} else {
		//IAMCameraControl
		prop -= EXC_VPAMPMAX;
		m_hr = m_dshow[id].pIAMCameraControl->GetRange( prop, &Min, &Max, &Step, &Default, &Flags );
		if ( FAILED(m_hr) ) return EXC_ERROR;
		//Manulalݒ
		m_hr = m_dshow[id].pIAMCameraControl->Get( prop, &Val, &Flags );
		m_hr = m_dshow[id].pIAMCameraControl->Set( prop, Val, CameraControl_Flags_Manual );
		if ( FAILED(m_hr) ) return EXC_ERROR;
	}
	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// ݒ荀ڂLǂׂ
int ExCapture::PropIsAvailable( int id, int prop ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;
	if ( prop < 0 || prop >= EXC_ITEMMAX ) return EXC_ERROR;
	if ( m_dshow[id].valueflag[prop] ) return EXC_SUCCESS;
	else							  return EXC_ERROR;
}
// 邳[hɂ
int ExCapture::SetBrightnessAuto( int id ) {
	return SetAuto( id, EXC_BRIGHTNESS );
}
// 邳蓮[hɂ
int ExCapture::SetBrightnessManu( int id ) {
	return SetManu( id, EXC_BRIGHTNESS );
}
// 邳蓮[hɂāCݒlύX
int ExCapture::SetBrightness( int id, double value ) {
	return SetValue( id, EXC_BRIGHTNESS, value );
}
// 邳̐ݒlǂݏo
double ExCapture::GetBrightness( int id ) {
	return GetValue( id, EXC_BRIGHTNESS );
}

// RgXg[hɂ
int ExCapture::SetContrastAuto( int id ) {
	return SetAuto( id, EXC_CONTRAST );
}
// RgXg蓮[hɂ
int ExCapture::SetContrastManu( int id ) {
	return SetManu( id, EXC_CONTRAST );
}
// RgXg蓮[hɂāCݒlύX
int ExCapture::SetContrast( int id, double value ) {
	return SetValue( id, EXC_CONTRAST, value );
}
// RgXg̐ݒlǂݏo
double ExCapture::GetContrast( int id ) {
	return GetValue( id, EXC_CONTRAST );
}

// ʓx[hɂ
int ExCapture::SetSaturationAuto( int id ) {
	return SetAuto( id, EXC_SATURATION );
}
// ʓx蓮[hɂ
int ExCapture::SetSaturationManu( int id ) {
	return SetManu( id, EXC_SATURATION );
}
// ʓx蓮[hɂāCݒlύX
int ExCapture::SetSaturation( int id, double value ) {
	return SetValue( id, EXC_SATURATION, value );
}
// ʓx̐ݒlǂݏo
double ExCapture::GetSaturation( int id ) {
	return GetValue( id, EXC_SATURATION );
}

// zCgoX[hɂ
int ExCapture::SetWhitebalanceAuto( int id ) {
	return SetAuto( id, EXC_WHITEBALANCE );
}
// zCgoX蓮[hɂ
int ExCapture::SetWhitebalanceManu( int id ) {
	return SetManu( id, EXC_WHITEBALANCE );
}
// zCgoX蓮[hɂāCݒlύX
int ExCapture::SetWhitebalance( int id, double value ) {
	return SetValue( id, EXC_WHITEBALANCE, value );
}
// zCgoX̐ݒlǂݏo
double ExCapture::GetWhitebalance( int id ) {
	return GetValue( id, EXC_WHITEBALANCE );
}

// ڂ蒲[hɂ
int ExCapture::SetIrisAuto( int id ) {
	return SetAuto( id, EXC_IRIS );
}
// ڂ蒲蓮[hɂ
int ExCapture::SetIrisManu( int id ) {
	return SetManu( id, EXC_IRIS );
}
// ڂ蒲蓮[hɂāCݒlύX
int ExCapture::SetIris( int id, double value ) {
	return SetValue( id, EXC_IRIS, value );
}
// ڂ蒲̐ݒlǂݏo
double ExCapture::GetIris( int id ) {
	return GetValue( id, EXC_IRIS );
}

// tH[JX[hɂ
int ExCapture::SetFocusAuto( int id ) {
	return SetAuto( id, EXC_FOCUS );
}
// tH[JX蓮[hɂ
int ExCapture::SetFocusManu( int id ) {
	return SetManu( id, EXC_FOCUS );
}
// tH[JX蓮[hɂāCݒlύX
int ExCapture::SetFocus( int id, double value ) {
	return SetValue( id, EXC_FOCUS, value );
}
// tH[JX̐ݒlǂݏo
double ExCapture::GetFocus( int id ) {
	return GetValue( id, EXC_FOCUS );
}




//------------------------------------------------------------------------------------
// 摜̉TCYԂ
int ExCapture::Width( int id ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return 0;
	return m_dshow[id].Bmi.bmiHeader.biWidth;
}
//------------------------------------------------------------------------------------
// 摜̏cTCYԂ
int ExCapture::Height( int id ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return 0;
	return m_dshow[id].Bmi.bmiHeader.biHeight;
}
//------------------------------------------------------------------------------------
// t[[gԂ
double ExCapture::FPS( int id ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return -1.0;
	return m_dshow[id].fps;
}
//------------------------------------------------------------------------------------
// t[obt@TCY(P:oCg)Ԃ
int ExCapture::SizeImage( int id ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return 0;
	return m_dshow[id].bufsize;
}
//------------------------------------------------------------------------------------
// ݂̃obt@AhX擾
int ExCapture::GetBufferAddress( int id, void **buffer ) {
	if ( m_flag_open != EXC_SUCCESS ) {
		*buffer = NULL;
		return EXC_ERROR;
	}
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;
	*buffer = m_dshow[id].buffer;
	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// obt@AhXύX
int ExCapture::SetBufferAddress( int id, void *buffer ) {
	if ( m_flag_open != EXC_SUCCESS ) return EXC_ERROR;
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;
	if ( !buffer ) return EXC_ERROR;
	m_dshow[id].pbuf = (int*)buffer;
	m_dshow[id].SampleGrabberCB.pbuf_CB = m_dshow[id].pbuf;
	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// J̉摜擾
int ExCapture::GetImage( int id, void *buffer ) {
	if ( m_flag_open != EXC_SUCCESS ) return EXC_ERROR;
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;
	if ( !buffer ) return EXC_ERROR;
	// buffer̎TCYm_dshow[id].bufsize菬ꍇo
	memcpy_s( buffer, m_dshow[id].bufsize, m_dshow[id].pbuf, m_dshow[id].bufsize );
	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// V摜ǂmFD摜ĂEXC_SUCCESSԂ
int ExCapture::IsCaptured( int id, double *t ) {
	if ( m_flag_open != EXC_SUCCESS ) return EXC_ERROR;
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;
	if ( m_dshow[id].SampleGrabberCB.IsCaptured() == EXC_SUCCESS ) {
		if ( t != NULL ) m_dshow[id].SampleGrabberCB.TimeSet( t );
		return EXC_SUCCESS;
	}
	return EXC_ERROR;
}
//------------------------------------------------------------------------------------
// DirectShowfŌ̃G[bZ[W擾
void ExCapture::GetLastMessage( char *s, int size ) {
	wchar_t w[256];
	AMGetErrorText( m_hr, w, 256 );
	WideCharToMultiByte( CP_ACP, 0, w, -1, s, size, NULL, NULL );
}
//------------------------------------------------------------------------------------
// foCXI[vĂ邩mF
int ExCapture::IsOpened() {
	return m_flag_open;
}
//------------------------------------------------------------------------------------
// gp\ȃJԂ
int ExCapture::NumAvailable() {
	return m_use_num;
}
//------------------------------------------------------------------------------------
// JԍLǂ`FbN
int ExCapture::NumCheck( int id ) {
	if ( id < 0 || id >= m_use_num ) return EXC_ERROR;
	return EXC_SUCCESS;
}


//#ifdef _CXCORE_H_
//------------------------------------------------------------------------------------
// 摜̎擾
int ExCapture::GetImage( int id, IplImage **image ) {
	if ( m_flag_open != EXC_SUCCESS ) return EXC_ERROR;
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;

	// 摜obt@݂Ȃ摜TCY(oCg)ȂΉ摜obt@蒼
	if ( image[0] == NULL ) {
		if ( CreateImage( id, image ) != EXC_SUCCESS ) return EXC_ERROR;
	}
	if ( image[0]->imageSize != SizeImage(id) ) {
		if ( CreateImage( id, image ) != EXC_SUCCESS ) return EXC_ERROR;
	}

	// 摜Lv`
	if ( GetImage( id, (void*)image[0]->imageData ) != EXC_SUCCESS ) return EXC_ERROR;

	// ㉺t]̐ݒ
	if ( image[0]->origin == 0 ) cvFlip( image[0] );

	return EXC_SUCCESS;
}
//------------------------------------------------------------------------------------
// 摜obt@̊m image=NULLłȂ΂ȂȂ
int ExCapture::CreateImage( int id, IplImage **image ) {
	if ( m_flag_open != EXC_SUCCESS ) return EXC_ERROR;
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;

	if ( image[0] != NULL ) cvReleaseImage( image );
	image[0] = NULL;

	image[0] = cvCreateImage( cvSize(m_dshow[id].Bmi.bmiHeader.biWidth,m_dshow[id].Bmi.bmiHeader.biHeight), IPL_DEPTH_8U, 3 );
	if ( image[0] == NULL ) return EXC_ERROR;

	return EXC_SUCCESS;
}
//#endif


// Qcam Orbit AF̃JjJp`g֘A
// :http://www.quickcamteam.net/documentation/how-to/how-to-control-pan-tilt-zoom-on-logitech-cameras/?searchterm=None
//
// Qcam Orbit AF̃p`gʒuZbg
int ExCapture::OrbitResetPanTlt( int id ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;

	long flags = KSPROPERTY_CAMERACONTROL_FLAGS_RELATIVE | KSPROPERTY_CAMERACONTROL_FLAGS_MANUAL;
	bool flag_failed = false;
/*
	m_hr = m_dshow[id].pIAMCameraControl->Set( CameraControl_Pan, 180, flags );
	if ( FAILED(m_hr) ) flag_failed = true;
	Sleep(1500);
	m_hr = m_dshow[id].pIAMCameraControl->Set( CameraControl_Tilt, 180, flags );
	if ( FAILED(m_hr) ) flag_failed = true;
	Sleep(1000);
	m_hr = m_dshow[id].pIAMCameraControl->Set( CameraControl_Pan, -64, flags );
	if ( FAILED(m_hr) ) flag_failed = true;
	Sleep(1000);
	m_hr = m_dshow[id].pIAMCameraControl->Set( CameraControl_Tilt, -24, flags );
	if ( FAILED(m_hr) ) flag_failed = true;
	Sleep(500);
*/
	
	while( HRESULT_FROM_WIN32(ERROR_BUSY) == m_dshow[id].pIAMCameraControl->Set( CameraControl_Pan, 180, flags ) );
	while( HRESULT_FROM_WIN32(ERROR_BUSY) == m_dshow[id].pIAMCameraControl->Set( CameraControl_Tilt, 180, flags ) );
	while( HRESULT_FROM_WIN32(ERROR_BUSY) == m_dshow[id].pIAMCameraControl->Set( CameraControl_Pan, -64, flags ) );
	while( HRESULT_FROM_WIN32(ERROR_BUSY) == m_dshow[id].pIAMCameraControl->Set( CameraControl_Tilt, -24, flags ) );

	if ( flag_failed ) return EXC_ERROR;
	return EXC_SUCCESS;
}

// Qcam Orbit AF̑ΓIpʒuZbg
int ExCapture::OrbitSetPanRelative( int id, int pos ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;

	long flags = KSPROPERTY_CAMERACONTROL_FLAGS_RELATIVE | KSPROPERTY_CAMERACONTROL_FLAGS_MANUAL;

	m_hr = m_dshow[id].pIAMCameraControl->Set( CameraControl_Pan, pos, flags );
	if ( FAILED(m_hr) ) return EXC_ERROR;
	return EXC_SUCCESS;
}

// Qcam Orbit AF̑ΓI`gʒuZbg
int ExCapture::OrbitSetTltRelative( int id, int pos ) {
	if ( NumCheck( id ) != EXC_SUCCESS ) return EXC_ERROR;

	long flags = KSPROPERTY_CAMERACONTROL_FLAGS_RELATIVE | KSPROPERTY_CAMERACONTROL_FLAGS_MANUAL;

	m_hr = m_dshow[id].pIAMCameraControl->Set( CameraControl_Tilt, pos, flags );
	if ( FAILED(m_hr) ) return EXC_ERROR;
	return EXC_SUCCESS;
}





